-----------------------------------------------------------------------------------------------
-- Client Lua Script for MagicCrateBox
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- MagicCrateBox Module Definition
-----------------------------------------------------------------------------------------------
local MagicCrateBox = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function MagicCrateBox:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here
 self.crateBoxAnswers = {
	"Crate is certain.",
	"Crate is decidedly so.",
	"Crate is without a doubt.",
	"Crate is most definate.",
	"You may rely on it, Crate has spoken.",
	"As Crate see's it, so shall it be.",
	"Most likely, so saieth Crate.",
	"Outlook good, according to Crate.",
	"Yes, Crate yes.",
	"Crate points to yes.",
	"The Crate is hazy, try again later.",
	"Ask Crate again later.",
	"Crate know's better than to tell you now.",
	"Crate cannot predict this now.",
	"Crate wishes you to concentrate, and Crate again.",
	"Do not Crate on it.",
	"Crate's reply is no.",
	"Crate's packing list says no.",
	"Outlook not so Crate.",
	"Crate is very doubtful on this."
}

    return o
end

function MagicCrateBox:Init()
    Apollo.RegisterAddon(self)
end
 

-----------------------------------------------------------------------------------------------
-- MagicCrateBox OnLoad
-----------------------------------------------------------------------------------------------
function MagicCrateBox:OnLoad()
    -- Register handlers for events, slash commands and timer, etc.
    -- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)
    Apollo.RegisterSlashCommand("cratebox", "OnMagicCrateBoxOn", self)
    
    -- load our forms
    self.wndMain = Apollo.LoadForm("MagicCrateBox.xml", "MagicCrateBoxForm", nil, self)
    self.wndMain:Show(false)
    
end


-----------------------------------------------------------------------------------------------
-- MagicCrateBox Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-- on SlashCommand "/cratebox"
function MagicCrateBox:OnMagicCrateBoxOn()
	self.wndMain:Show(true) -- show the window
end


-----------------------------------------------------------------------------------------------
-- MagicCrateBoxForm Functions
-----------------------------------------------------------------------------------------------
-- when the OK button is clicked
function MagicCrateBox:OnOK()

end

-- when the Cancel button is clicked
function MagicCrateBox:OnCancel()
	self.wndMain:Show(false) -- hide the window
end


function MagicCrateBox:onCrate( wndHandler, wndControl, eMouseButton )
local crateBoxAnswers = {}
local crateIsValid = self.wndMain:FindChild("askBox"):GetText():len()
local crateReply = self.wndMain:FindChild("Disclaimer")
Event_FireGenericEvent("SendVarToRover", "crateReplys", self.crateBoxAnswers)
Event_FireGenericEvent("SendVarToRover", "crateIsValid", crateIsValid)
Event_FireGenericEvent("SendVarToRover", "Disclaimer", crateReply)
	if crateIsValid ~= 0 then
	local intRand = math.random(1,20)
	local strReply = self.crateBoxAnswers[intRand]
		crateReply:SetText(strReply)
	end
end

-----------------------------------------------------------------------------------------------
-- MagicCrateBox Instance
-----------------------------------------------------------------------------------------------
local MagicCrateBoxInst = MagicCrateBox:new()
MagicCrateBoxInst:Init()
